#include <climits>
#include <vector>
#include <utility>

#define Coord pair<int, int>
#define CoordVector vector<pair<int, int>>

using namespace std;

class Pathfinder {
 int *field;
 Coord start;
 Coord end;
 int size_x;
 int size_y;
 int *indexes;
 CoordVector path;
 void Backtrace();
 bool MarkPoint(int i, int j, int n);
public:
 Pathfinder(int *field, int size_x, int size_y);
 CoordVector* CalculatePath();
 int *GetIndexedMap() { return indexes; }
 ~Pathfinder();
};

